﻿Imports System.ComponentModel

Public Class Form1

    Private ocr As OCR

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ocr = New OCR
        CbOcrLanguages.Enabled = False
        BtOcrFromImage.Enabled = False
        BtOcrFromImageHandle.Enabled = False
        If ocr.GetIsOcrInitialized Then
            Me.Text = "OCR Sample [MaxImageDimension = " &
                ocr.GetMaxOcrImageDimension.ToString & " x " &
                ocr.GetMaxOcrImageDimension.ToString & " Pixel]"
            Dim intCount As Integer = ocr.GetAvailableOcrLanguagesCount
            If intCount > 0 Then
                For intItem = 0 To intCount - 1
                    CbOcrLanguages.Items.Add(ocr.GetAvailableOcrLanguageDisplayName(intItem) & " (" &
                                          ocr.GetAvailableOcrLanguageTag(intItem) & ")")
                Next
                CbOcrLanguages.Enabled = True
                CbOcrLanguages.SelectedIndex = 0
            End If
        End If
    End Sub

    Private Sub Form1_Closing(sender As Object, e As CancelEventArgs) Handles Me.Closing
        ocr.Dispose()
    End Sub

    Private Sub CbOcrLanguages_SelectedIndexChanged(sender As Object, e As EventArgs) Handles CbOcrLanguages.SelectedIndexChanged
        BtOcrFromImage.Enabled = False
        BtOcrFromImageHandle.Enabled = False
        If ocr.InitOcrEngineByLanguageIndex(CbOcrLanguages.SelectedIndex) Then
            BtOcrFromImage.Enabled = True
            BtOcrFromImageHandle.Enabled = True
        End If
    End Sub

    Private Sub BtOcrFromImage_Click(sender As Object, e As EventArgs) Handles BtOcrFromImage.Click
        Dim strFileName As String = String.Empty
        Using OFD As New OpenFileDialog
            With OFD
                .Title = "Open Image File"
                ' und andere Bildformate
                .Filter = "BMP Files (*.bmp)|*.bmp|" &
                          "JPG Files (*.jpg)|*.jpg|" &
                          "PNG Files (*.png)|*.png|" &
                          "GIF Files (*.gif)|*.gif"
                .FilterIndex = 2
                .ShowDialog()
                strFileName = .FileName
            End With
        End Using

        If Not String.IsNullOrEmpty(strFileName) Then
            Me.Text = "Bitte warten..."
            If ocr.GetOcrResultsFromImageFile(strFileName) Then
                TbOcrResult.Text = ocr.GetOcrResultTextCompleteWithLineBreak
                Me.Text = "Fertig"

                'Debug.Print("OcrResultTextAngle: " & ocr.GetOcrResultTextAngle.ToString)
                'Debug.Print("OcrResultTextComplete: " & ocr.GetOcrResultTextComplete)
                'Debug.Print("OcrResultLanguageDisplayName: " & ocr.GetUsedOcrResultLanguageDisplayName)
                'Debug.Print("OcrResultLanguageNativeName: " & ocr.GetUsedOcrResultLanguageNativeName)
                'Debug.Print("OcrResultLanguageTag: " & ocr.GetUsedOcrResultLanguageTag)
                'Debug.Print("OcrResultLanguageScript: " & ocr.GetUsedOcrResultLanguageScript)

                'Dim intLineCount As Integer = ocr.GetOcrResultTextLineCount
                'If intLineCount > 0 Then
                '    For intLineIndex As Integer = 0 To intLineCount - 1
                '        Debug.Print("TextLine" & (intLineIndex + 1).ToString & ": " & ocr.GetOcrResultTextLineByIndex(intLineIndex))
                '        Dim intLineWordCount As Integer = ocr.GetOcrResultTextLineByIndexWordsCount(intLineIndex)
                '        If intLineWordCount > 0 Then
                '            For intLineWordIndex As Integer = 0 To intLineWordCount - 1
                '                Debug.Print("    Word" & (intLineWordIndex + 1).ToString & ": " &
                '                            ocr.GetOcrResultTextLineByIndexWordByIndex(intLineIndex, intLineWordIndex) & " [Position: " &
                '                            ocr.GetOcrResultTextLineByIndexWordRectByIndex(intLineIndex, intLineWordIndex).ToString & "]")
                '            Next
                '        End If
                '        Debug.Print(New String("-"c, 30))
                '    Next
                'End If

            End If
        End If
    End Sub

    Private Sub BtOcrFromImageHandle_Click(sender As Object, e As EventArgs) Handles BtOcrFromImageHandle.Click
        Me.Text = "Bitte warten..."
        If ocr.GetOcrResultsFromBitmap(My.Resources.OcrTest) Then
            TbOcrResult.Text = ocr.GetOcrResultTextCompleteWithLineBreak
            Me.Text = "Fertig"
        End If
    End Sub
End Class
